import { useEffect } from 'react';
/**
 * 只在组件 mount 时执行的 Hook。
 *
 * @param {Function} fn 组件 `mount` 时执行的函数。
 * @example
 * useMount(() => {
 *   console.log('mount');
 * });
 */
var useMount = function (fn) {
    useEffect(function () {
        fn();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
};
export default useMount;
