import { __read } from "tslib";
import { useCallback } from 'react';
import useSafeState from '../useSafeState';
/**
 * 强制组件重新渲染的 Hook。
 *
 * 内部使用了 `useSafeState`，调用时如果组件已经卸载则不会触发。
 * @returns
 * @example
 * const update = useUpdate();
 */
var useUpdate = function () {
    var _a = __read(useSafeState(0), 2), setState = _a[1];
    var update = useCallback(function () {
        setState(function (num) { return num + 1; });
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return update;
};
export default useUpdate;
