"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
/**
 * 只在组件 mount 时执行的 Hook。
 *
 * @param {Function} fn 组件 `mount` 时执行的函数。
 * @example
 * useMount(() => {
 *   console.log('mount');
 * });
 */
var useMount = function (fn) {
    (0, react_1.useEffect)(function () {
        fn();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
};
exports.default = useMount;
