/**
 * 返回上一次的 state 或 props 。
 *
 * @param state 需要记录变化的值。
 * @returns 上一次记录的值。
 * @example
 * const [value, setValue] = useState('');
 * // 上一次 state 的值。
 * const prevValue = usePrevious(value);
 */
declare function usePrevious<T>(state: T): T | undefined;
export default usePrevious;
